/*
  DRAWING BIOS DEFINATIONS for Borland C++ / LSIC-86
  BY M.YANAGISAWA(@MoroboshiLUM)
*/

#include "generic.h"

enum	{_WRITEMODE_RPL,_WRITEMODE_AND, _WRITEMODE_OR,_WRITEMODE_XOR};

/* GRAPHICS BIOS */
#define DRAW_BIOS 		0x32
#define GRPHDATA_BIOS 	0x33

/* DRAWING FUNCTIONS */
#define DRAW_INIT		0
#define DRAW_SETPATTERN	1
#define DRAW_SETCLIPAREA 2
#define DRAW_POINT		3
#define DRAW_LINE		4
#define DRAW_BOX		5
#define DRAW_FILLAREA	6
#define DRAW_PUTIMAGE	7
#define DRAW_PUTKANJI	8
#define DRAW_GETIMAGE	9

/* ------- COMMON PACK-STRUCTURE ------- */

typedef struct DRAW_COMMON_PACS	{
	int x1;
	int y1;
	int x2;
	int y2;
	int mode;
	int size;
	int style;
} TDRAW_COMMON_PACS,far *LPDRAW_COMMON_PACS;

/* clip param */
typedef struct SETCLIPAREA_PACS	{

	int sx;
	int sy;
	int ex;
	int ey;

} TSETCLIPAREA_PACS,far *LPSETCLIPAREA_PACS;

/* line drawing param */
typedef struct DRAWLINE_PACS {

	int x1;
	int y1;
	int x2;
	int y2;
	int mode;
	int size;
	int style;

} TDRAWLINE_PACS,far *LPDRAWLINE_PACS;

/* Area fill param */
typedef struct FillArea_PACS {
	int sx;
	int sy;
	int ex;
	int ey;
} TFILLAREA_PACS,far *LPFILLAREA_PACS;

/* put image param */
typedef struct PutImage_PACS {

	int x;
	int y;
	int width;
	int height;
	int mode;
	int ofs;
	int seg;

} TPUTIMAGE_PACS,far *LPPUTIMAGE_PACS;

/* put kanji param */
typedef struct PutKanji_PACS {

	int x;
	int y;
	unsigned int code;
	int mode;

} TPUTKANJI_PACS,far *LPPUTKANJI_PACS;

/* get image param */
typedef struct GetImage_PACS {

	int x;
	int y;
	int width;
	int height;
	int DUMMY;
	int ofs;
	int seg;

} TGETIMAGE_PACS,far *LPGETIMAGE_PACS;

/* Library */
void Grph_PutKanji(int x,int y,unsigned int code,int mode);
void Grph_PutImage(int x,int y,int width,int height,int mode,void far *body);
void Grph_GetImage(int x,int y,int width,int height,void far *body);
void Grph_FillArea(int x1,int y1,int x2,int y2,int mode,int depth);
void Grph_Box(int x1,int y1,int x2,int y2,int mode,int size,int style);
void Grph_Line(int x1,int y1,int x2,int y2,int mode,int size,int style);
void Grph_Pset(int x,int y,int mode,int size);
void Grph_SetDepth(int depth);
void Grph_SetArea(int x1,int y1,int x2,int y2);
void Grph_Init(void);

BOOL Grph_GetImageData(int num,int *x,int *y,void far **data);

#ifdef __BORLANDC__
/* for debug */
void DrawGetImage(void);
void DrawPutImage(void);
void DrawPutKanji(void);
void SetClipArea(void);
void FillArea(void);
void DrawBox(void);
void DrawLine(void);
void PutPixel(void);
void SelectPattern(void);
void InitSimpleDraw(void);

#endif
