/* MPROM Generic definations  by M.yanagisawa.  */

#include "generic.h"

/* MPEG INFORMATION */
typedef struct _MPEGINFO {
  int version;
  int layer;
  int errorprotection;
  int bitrate_index;
  int sfreq_index;
  int padding;
  int extention;
  int mode_index;
  int modeextention;
  BOOL copyright;
  BOOL original;
  int emphasis_index;
  DWORD frames;
  DWORD playbacktime;
} TMPEGINFO,far *LPMPEGINFO;

typedef struct _PLAYLIST {
  DWORD lba;
  DWORD size;
  char filename[24];
} TPLAYLIST,far *LPPLAYLIST;

void monitor(void);   /* DEBUG MONITOR */

extern char dispbuf[256];   /* for display buffer*/

/* Global variables */
extern int TrackNum;
extern DWORD TrackLba[100];
extern BOOL isAudioTrack[100];
extern BYTE far *DirTbl;
extern BYTE far *LocalBuf; /* Global Read Buffer(tmp) */
extern DWORD RootLBA;
extern DWORD RootDir;
extern DWORD RootDirLen;
extern int DirFiles;
extern int TrueDirFiles;
extern DWORD Loadedsize;
extern BOOL ISJOLIET;

/* Key definations */
enum {_KEY_OF_FUNC,_KEY_OF_ALL,_KEY_OF_3,_KEY_OF_VOLUP,_KEY_OF_ESC,_KEY_OF_EXEC,_KEY_OF_STOP,_KEY_OF_VOLDOWN, /* PA */
      _KEY_OF_UP,_KEY_OF_DOWN, _KEY_OF_RIGHT,_KEY_OF_LEFT };  /* PB */
#define _KEY_OF_SELECT _KEY_OF_STOP     /**/
#define _KEY_OF_PLAY   _KEY_OF_VOLDOWN  /**/

enum { _AUDIO_DISC,_DATA_DISC,_MIXED_DISC };

enum { _REQUEST_CHANGEDISC=1,_REQUEST_AUDIOMODE,_REQUEST_DATAMODE };

enum { _STOPPLAYING, _PLAYING, _LAST_BUFFER_PLAYING,_LAST_BUFFER_SET };

#define MAX_FILEDIR 256	/* max 256 files @ 1folder */

/* displaying data axis */
#define SCR_WIDTH 640
#define SCR_HEIGHT 200
#define CHR_WIDTH 8

#define DISP_COL1_S 3
#define DISP_COL1_E 315
#define DISP_COL2_S 324
#define DISP_COL2_E 636

#define RAW_SIZE 17
#define MAX_MSGWIDTH 500 /**/
#define MAX_DISPLINE 9
#define MAX_DISPLINE_AUDIO 10
#define MAX_DIRMAP (MAX_DISPLINE * 2)

#define MAX_OVERLAP 2  	/* Overlap windows */

/* local read buffer */
#define LOCAL_BUFSIZE 0xffe0

/* LCD VRAM Steal area */
#ifdef __BORLANDC__

/* for IBM-PC/AT VGA */
#define _VRAM_BASE  ((BYTE far *)0xa0000000UL)
#define _VRAM_SIZE  (640 / 8 * 480)

#else

#define _VRAM_BASE  ((BYTE far *)0x70000000UL)
#define _VRAM_SIZE  (640 / 8 * 200)

#endif

#define AFONT_SIZE 16  /* 8(1byte) * 16 */
#define KFONT_SIZE 32  /* 16(2byte) * 16 */

#define BTN_WIDTH 56
#define BTN_HEIGHT 22

#define _MSGDLG_2BTN 0
#define _MSGDLG_1BTN 1
#define _MSGDLG_NOBTN 2
#define _MSGDLG_NOBTN_NOCLOSE 3

#define _MSG_XOFS 16
#define _MSG_YOFS 4
#define _MSG_XBTNOFS 4
#define _MSG_YBTNOFS 6

#define MP3INFO_X1     20
#define MP3INFO_Y1     10
#define MP3INFO_X2     619
#define MP3INFO_Y2     189
#define MP3INFO_WIDTH (MP3INFO_X2-MP3INFO_X1+1)
#define MP3INFO_HEIGHT (MP3INFO_Y2-MP3INFO_Y1+1)

#define MP3INFO_TAGWIDTH 280

#define MP3INFOTIME_X (MP3INFO_X1+_MSG_XOFS+8*3)
#define MP3INFOTIME_Y (MP3INFO_Y1+_MSG_YOFS+RAW_SIZE*3)

/* MUST BE WORD ORDER :) */
typedef struct {
   char filename[66]; /**/ 
   BYTE flag;
   BOOL ismp3;
   DWORD lba;
   DWORD size;
} FILETYPE;
typedef FILETYPE far *LPFILETYPE, *PFILETYPE;

typedef struct {
  int x;
  int y;
  int width;
  int height;
  void far *buf;
} TWinStack,far *LPWinStack;

typedef struct _ID3TAG {
  char ID[3];
  char title[30];
  char artist[30];
  char album[30];
  char year[4];
  char comment[30];
  unsigned char genre;
} TID3TAG,far *LPID3TAG;

#ifdef __BORLANDC__
void far_memset(BYTE far *p,BYTE dat,int size);
#endif

/* functions Prototypes */
void DELAY(int cnt);
void DELAY10MS(int cnt);
int cddaplay(int track);
void InitDMAU(void);
void SetDMAUMode(BYTE ch,BOOL flg);
void SetDMAU(BYTE ch,void far *addr,DWORD size,BOOL IsInit);
int mp3play(int index,int playcnt);
void disptime(BOOL isSign,int x,int y,long sec);
void strncpy_far(char far *dest,char far *src,int max);
BOOL CheckMP3Info(DWORD info,DWORD len,LPMPEGINFO minfo);
BOOL LoadID3Tag(DWORD lba,DWORD size,BYTE far *buf);
BOOL messagedlg(char *msg,int mode);
void flashbtn(int x,int y,BYTE *s);
void drawbtn(int x,int y,BYTE *s);
void CutStr(int max,BYTE *s);
void DivStr(BYTE *s,BYTE *d1,BYTE *d2);
void closewindow(void);
void openwindow(int x1,int y1,int x2,int y2);
void vram_clear(void);
void draw_window(int x1,int y1,int x2,int y2);
void dispbackground(void);
void dispbackground_audio(void);
void putmessage(int cx,int cy,BYTE far *s);
void putkanji(int x,int y,WORD code);
BYTE far *GetZFont(WORD code);
BYTE far *getvram(int cx,int cy);
long GetFontOfs(WORD code);
void waitnotkeypressed(void);
int readkeypressed(void);
int readkey(void);
WORD Unicode2SJIS(WORD code);
void lcd_onoff(BOOL OnOff);
void disp_onoff(BOOL OnOff);
void steal_onoff(BOOL OnOff);
void InitTimer(void);
void DispCursor(int prevcsr,int csr,int max,int depth);
void CursorKey(int c,int *csr,int *top,int filemaxptr,int max);
int LoadingData(BYTE far *p,DWORD bufsize,DWORD lba,DWORD size);
BOOL DispTrack(int top);
void MakeDispTrStr(int tr,long trlen,char *s);
BOOL DispDirectory2(int top);
void MakeDispStr(int n,char *s,LPFILETYPE p);
BOOL LoadDirectory(DWORD lba,DWORD length,BOOL isJoliet);
BOOL CheckMP3(BYTE far *s);
void CopyFilenameUnicode(BYTE far *s,BYTE far *p);
void CopyFilename(BYTE far *s,BYTE far *p);
BOOL ReadPathTable(void);
void SetVolumeTime(BYTE far *p);
void CopyVolumeLabel(BYTE far *p);
void CopyVolumeLabelUnicode(BYTE far *p);
void fstrcpy(char far *d,char far *s);
BOOL GetTrackInfo(BOOL *isExistDataTrack);
BOOL PlayFile(DWORD lba,DWORD ofs,DWORD size);
void StopFile(void);
void mainmenu(void);
int CDDA_MENU(void);
int MP3_MENU(void);
void DispVolumeInfo(BOOL isJoliet);
int addplaylist(DWORD lba,DWORD size,char far *s);
void deleteplaylist(int index);
BOOL getplaylist(int index,LPPLAYLIST *ptr);
void clearplaylist(void);
LPPLAYLIST getplaylistptr(int index);
int getindex(DWORD lba,DWORD size);
