/* MPROM Firmware Code version 1.0 (RS-232C Debug I/O Library)       */
/* programmed by M.yanagisawa(MoroboshiLUM)  elfin@mth.biglobe.ne.jp */
/* Copyright (c) 2000 by M.yanagisawa. All rigths reserved.          */

#ifdef __BORLANDC__

#include <stdio.h>
#include <dos.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <alloc.h>

#else

#include <stdrom.h>

#endif

#include "generic.h"
#include "rslib.h"

BOOL isOpened = FALSE;

void initcomm(void)
{
#ifndef __BORLANDC__
   union REGS i,o;

   i.h.ah=COM_OPEN;
   int86(COMMBIOS,&i,&o);
#endif
   isOpened=TRUE;
}

void PUTCHAR(char c)
{
   union REGS i,o;

   if (!isOpened) return;
   do {
     i.h.ah=COM_SEND;
     i.h.dl=(BYTE)c;
     int86(COMMBIOS,&i,&o);
   } while (o.x.ax!=0);
}

char GETCHAR(int isecho)
{
   union REGS i,o;

   if (!isOpened) return(0);
   do {
     i.h.ah=COM_RECV;
     int86(COMMBIOS,&i,&o);
   } while (o.x.ax!=0);
   if (isecho) PUTCHAR(o.h.dl);  /* ECHO BACK */
   return(o.h.dl);
}

void PUTMSG(char *s)
{
   if (!isOpened) return;
   while (*s) PUTCHAR(*s++);
}

void putmsg(char *s)
{
#ifdef __BORLANDC__
   cputs(s);
#else
   PUTMSG(s);
#endif
}

void getmsg(int isecho,char *s)
{
#ifdef __BORLANDC__
   gets(s);
#else
   char c;
   int i=0;

   if (!isOpened) {
     *s=0;
     return;
   }
   while (i<MAX_INPUT_LEN) {
     c=GETCHAR(0);
     if (c==_TAB) c=' ';
     if (c==_BS) {
       if (i>0) {
         if (isecho) {
           PUTCHAR(_BS);
           PUTCHAR(' ');
           PUTCHAR(_BS);
         }
         i--;
         s--;
       }
       continue;
     }
     if ((c==_CR) || (c==_LF)) {
       *s=0;
       if (isecho) PUTCHAR(c);
       if ((c==_CR) && isecho) PUTCHAR(_LF);  /* LF back. */
       return;
     }
     *s++=c; i++;
     if (c==_ESC) break;
     if (isecho) PUTCHAR(c);
   }
   *s=0;
#endif
}
