; V53A IO DEFINATIONS & PARAMETERS
; programmed by M.yanagisawa(MoroboshiLUM)

; V53A INTERNAL I/O PORTS DEF.
PGR_BASE = 0ff00H

XAM = 0ff80H
BSEL = 0ffe0H
BADR = 0ffe1H
BRC = 0ffe9H

;; Wait Control 0
WMB0 = 0ffeaH
WCY1 = 0ffebH
WCY0 = 0ffecH
WAC = 0ffedH

;;
TCKS = 0fff0H
SBCR = 0fff1H
REFC = 0fff2H

;; Wait Control 1
WMB1 = 0fff3H
WCY2 = 0fff4H
WCY3 = 0fff5H
WCY4 = 0fff6H

SULA = 0fff8H
TULA = 0fff9H
IULA = 0fffaH
DULA = 0fffbH
OPHA = 0fffcH
OPSEL = 0fffdH
SCTL = 0fffeH

;; SYSTEM CONTROL REGISTER PARAMETER
SCTL_INITPARAM	=	00010001B   ;
OPSEL_INITPARAM	=	00001111B	; SIU,TCU,ICU,DMAU ALL USED.
OPHA_INITPARAM	=	0E0H		; E0XXH
DULA_INITPARAM	=	00H			; DMA LOW BASE ADDRESS
IULA_INITPARAM	=	10H			; ICU LOW BASE ADDRESS
TULA_INITPARAM	=	20H			; TCU LOW BASE ADDRESS
SULA_INITPARAM	=	30H			; SIU LOW BASE ADDRESS
BANK_INITPARAM	=	40H			; BANK LOW BASE ADDRESS
TCKS_INITPARAM	=	00000000B	; TCU USE ALL INSIDE OSC, AND 1/4 DIV.
BRC_INITPARAM	=	20			; 24.576MHz @38400BPS BF=16

;; WAITINITIALIZE PARAMETERS
;; ROM = 120NS -> 0WAIT @12.288MHz 80000H - 17FFFFH
;; RAM = 70NS  -> 0WAIT
WMB0_INITPARAM	=	00000111B
WCY0_INITPARAM	=	00000000B	; 0WAIT
WCY1_INITPARAM	=	00000000B	; 0WAIT
WMB1_INITPARAM	=	01110111B	; 512K/512K
WAC_INITPARAM	=	00000000B	; 0XXXXXH
WCY2_INITPARAM	=	00000000B	; 0WAIT
WCY3_INITPARAM	=	00000000B	; IO=0WAIT,UMB=0WAIT
WCY4_INITPARAM	=	00000000B	; DMA CYCLE(RAM-IO ONLY)=0/REFRESH CYCLE=0 
RFC_INITPARAM	=	00000000B	; REFRESH NOT USED.

;; Serial Ports
SIU_BASE	=	OPHA_INITPARAM*256+SULA_INITPARAM
rsSRB		=	0
rsSTB		=	0
rsSST		=	1
rsSCM		=	1
rsSMD		=	2
rsSIMK		=	3

;; ICU
ICU_BASE	=	OPHA_INITPARAM*256+IULA_INITPARAM


;; EXTEND ADDRESS ACCESS INSTRUCTION (MACRO)

BRKXA	MACRO	TBL
	DB	0FH,0E0H
	DB	TBL
	ENDM

RETXA	MACRO	TBL
	DB	0FH,0F0H
	DB	TBL
	ENDM
