/* ATA Interface function definations */
/* programmed by M.yanagisawa.        */

#include "generic.h"

/* ATAPI ports defination */
#define _BSY  0x80
#define _DRDY 0x40
#define _DRQ  0x08
#define _ERR  0x01

#define _ATAPI_IO 0x02
#define _ATAPI_CD 0x01

/* Atapi status definations */
enum { _NODATA,_DATAREAD,_DATAWRITE };
enum {ATAPI_RECEIVE_DATA,ATAPI_WAITING_COMMAND,ATAPI_SEND_DATA,ATAPI_BUS_RELEASE,ATAPI_FINISH};

/* ATA execute error Status */
extern BYTE ERROR_STATUS;

#define ATA_COMMANDDELAY 1		/*1ms*/
#ifdef __BORLANDC__
#define TIMEOUT_CNT	3000000		/**/
#else
#define TIMEOUT_CNT	600000		/**/
#endif

typedef struct {
   BYTE cmd;
   BYTE feature;
   BYTE seccnt;
   BYTE secnum;
   BYTE cyllow;
   BYTE cylhigh;
   BYTE devhead;
} ATAPAC;

typedef struct {
   BYTE cmd;
   BYTE param[11];
} ATAPIPAC;

typedef ATAPAC* PATAPAC;
typedef ATAPIPAC* PATAPIPAC;

void clratapipac(PATAPIPAC pac);
void clratapac(PATAPAC pac);
WORD ConvSector(DWORD len);
BOOL ReadSector(DWORD lba,BYTE far *buf,int secnum);
BOOL SeekSector(DWORD lba);
BOOL isDeviceOK(void);
BOOL PlayStop(void);
BOOL PlayCD(DWORD sta,DWORD len);
BOOL TestUnitReady(void);
void RequestSense(BYTE far *buf);
BOOL ATAReset(void);
BOOL SendATAPICommand_INTR(ATAPIPAC *apac,int pacsize,BYTE far *p,int cnt);
BOOL SendATAPICommand(int _ACCTYPE,ATAPIPAC *apac,int pacsize,BYTE far *p,int cnt);
BOOL SendATACommand(PATAPAC pac);
int isPlaying(long *sec);
void SetFeature(BYTE mode);
BOOL GetLastSession(DWORD *lba);
